// ReplaceTextDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCSDI.h"

#include "CVMEditorDefs.h"
#include "ReplaceTextDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReplaceTextDlg dialog


CReplaceTextDlg::CReplaceTextDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReplaceTextDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReplaceTextDlg)
	m_bCaseSensitive = FALSE;
	m_csFindText = _T("");
	m_csReplaceText = _T("");
	m_bWholeWordsOnly = FALSE;
    m_bPromptOnReplace = FALSE;
    m_nDirection = 0;
    m_nScope = 0;
    m_nOrigin = 0;
	//}}AFX_DATA_INIT
}


void CReplaceTextDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReplaceTextDlg)
	DDX_Check(pDX, IDC_CASESENSITIVE, m_bCaseSensitive);
	DDX_Text(pDX, IDC_TEXTTOFIND, m_csFindText);
	DDX_Text(pDX, IDC_REPLACETEXT, m_csReplaceText);
	DDX_Check(pDX, IDC_WHOLEWORDS, m_bWholeWordsOnly);
	DDX_Check(pDX, IDC_PROMPTONREPLACE, m_bPromptOnReplace);
    DDX_Radio(pDX, IDC_FORWARD, m_nDirection);
    DDX_Radio(pDX, IDC_GLOBAL, m_nScope);
    DDX_Radio(pDX, IDC_FROMCURSOR, m_nOrigin);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CReplaceTextDlg, CDialog)
	//{{AFX_MSG_MAP(CReplaceTextDlg)
	ON_BN_CLICKED(IDYES, OnReplaceAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReplaceTextDlg message handlers

void CReplaceTextDlg::OnReplaceAll()
{
    // Replace all needs to return IDYES.  This is easier than
    // defining new return codes.
    if(!UpdateData(TRUE))
        return;

    EndDialog(IDYES);
}

void CReplaceTextDlg::SetOptions(FindReplaceStruct *frData)
{
    m_csFindText = frData->szFindStr;
    m_csReplaceText = frData->szReplaceStr;
    m_bCaseSensitive = ((frData->nOptions & efCaseSensitive) != 0);
    m_bWholeWordsOnly = ((frData->nOptions & efWholeWordsOnly) != 0);
    m_bPromptOnReplace = ((frData->nOptions & efPromptOnReplace) != 0);
    m_nDirection = ((frData->nDirection == efForward) ? 0 : 1);
    m_nScope = ((frData->nScope == efGlobal) ? 0 : 1);
    m_nOrigin = ((frData->nOrigin == efFromCursor) ? 0 : 1);
}

void CReplaceTextDlg::GetOptions(FindReplaceStruct *frData)
{
    strcpy(frData->szFindStr, m_csFindText);
    strcpy(frData->szReplaceStr, m_csReplaceText);

    frData->nOptions = frData->nDirection = frData->nScope =
        frData->nOrigin = 0;

    if(m_bCaseSensitive)
        frData->nOptions |= efCaseSensitive;

    if(m_bWholeWordsOnly)
        frData->nOptions |= efWholeWordsOnly;

    if(m_bPromptOnReplace)
        frData->nOptions |= efPromptOnReplace;

    frData->nDirection = ((m_nDirection) ? efBackward : efForward);
    frData->nScope = ((m_nScope) ? efSelectedText : efGlobal);
    frData->nOrigin = ((m_nOrigin) ? efEntireScope : efFromCursor);
}
